"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rx = require("rx");
const log4js = require("log4js");
const request = require("request");
const logger = log4js.getLogger('spiderjs-sdk-admin');
class Admin {
    constructor(url) {
        this.url = url;
    }
    login(accout) {
        return this
            .post('/admin/login', accout)
            .map((token) => {
            this.token = token;
            return token;
        });
    }
    accessKeyOfEngine() {
        return this
            .post('/admin/accesskey/engine');
    }
    accessKeyOfAgent() {
        return this
            .post('/admin/accesskey/agent');
    }
    post(method, params) {
        const headers = {};
        if (this.token) {
            headers.Authorization = `JWT ${this.token}`;
        }
        return rx.Observable.create((ob) => {
            request.post({
                body: params,
                headers,
                json: true,
                url: `${this.url}${method}`,
            }, (error, response, resp) => {
                if (error) {
                    ob.onError(error);
                    return;
                }
                if (resp.code !== 'SUCCESS') {
                    ob.onError(resp);
                    return;
                }
                ob.onNext(resp.data);
                ob.onCompleted();
            });
        });
    }
}
exports.Admin = Admin;
//# sourceMappingURL=admin.js.map