"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_typescript_1 = require("mocha-typescript");
const src_1 = require("../src");
const admin = new src_1.Admin('http://localhost:8080');
let engine;
const app = {
    description: '',
    lambda: [],
    name: '',
};
let executor;
let agent;
let EngineTest = class EngineTest {
    connectTest(done) {
        admin.login({
            password: 'admin',
            username: 'admin',
        }).subscribe(() => {
            done();
        });
    }
    accessKeyOfEngine(done) {
        admin
            .accessKeyOfEngine()
            .subscribe((key) => {
            engine = new src_1.Engine('http://localhost:8080', key);
            done();
        }, (error) => {
            done(error);
        });
    }
    accessKeyOfAgent(done) {
        admin
            .accessKeyOfAgent()
            .subscribe((key) => {
            agent = key;
            done();
        }, (error) => {
            done(error);
        });
    }
    connectEngine(done) {
        engine
            .connect()
            .subscribe(() => {
            done();
        }, (error) => {
            done(error);
        });
    }
    createApp(done) {
        engine
            .createApp(app)
            .subscribe((oid) => {
            app.oid = oid;
            done();
        }, (error) => {
            done(error);
        });
    }
    getApp(done) {
        engine
            .getApp(app.oid)
            .subscribe(() => {
            done();
        }, (error) => {
            done(error);
        });
    }
    createExecutor(done) {
        return engine
            .deploy(app.oid, agent.oid)
            .subscribe((oid) => {
            executor = oid;
            done();
        }, (error) => {
            done(error);
        });
    }
    getExecutor(done) {
        engine
            .getExecutor(executor)
            .subscribe(() => {
            done();
        }, (error) => {
            done(error);
        });
    }
    createTask(done) {
        engine
            .createTask(executor)
            .subscribe(() => {
            done();
        }, (error) => {
            done(error);
        });
    }
    deleteExecutor(done) {
        engine
            .undeploy(executor)
            .subscribe((oid) => {
            done();
        }, (error) => {
            done(error);
        });
    }
    deleteApp(done) {
        engine
            .deleteApp(app.oid)
            .subscribe(() => {
            done();
        }, (error) => {
            done(error);
        });
    }
};
__decorate([
    mocha_typescript_1.test('login test'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "connectTest", null);
__decorate([
    mocha_typescript_1.test('create access key of engine'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "accessKeyOfEngine", null);
__decorate([
    mocha_typescript_1.test('create access key of agent'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "accessKeyOfAgent", null);
__decorate([
    mocha_typescript_1.test('connect engine'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "connectEngine", null);
__decorate([
    mocha_typescript_1.test('create app'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "createApp", null);
__decorate([
    mocha_typescript_1.test('get app'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "getApp", null);
__decorate([
    mocha_typescript_1.test('create executor'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "createExecutor", null);
__decorate([
    mocha_typescript_1.test('get executor'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "getExecutor", null);
__decorate([
    mocha_typescript_1.test('create task'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "createTask", null);
__decorate([
    mocha_typescript_1.test('delete executor'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "deleteExecutor", null);
__decorate([
    mocha_typescript_1.test('delete app'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], EngineTest.prototype, "deleteApp", null);
EngineTest = __decorate([
    mocha_typescript_1.suite('engine test')
], EngineTest);
//# sourceMappingURL=admin_test.js.map